﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace DataGridPastFromExcel
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<string> Names { get; set; }
        public SampleData Trades { get; set; }

        public MainWindow()
        {
            InitializeComponent();

            Names = new ObservableCollection<string>() { "Joe", "Betty", "Margaret", "Mary", "Jim", "Gary", "Jerry" };
            Trades = new SampleData();
            this.DataContext = this;

            Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            FieldLayout layout = new FieldLayout();

            Field personField = new Field("SalesPersonName");
            personField.Settings.CellValuePresenterStyle = LayoutRoot.Resources["CellWithAutoCompleteBox"] as Style;
            layout.Fields.Add(personField);

            for (int i = 1; i <= 29; i++)
            {
                Field f = new Field("Property" + i);
                f.Row = 0;
                f.Column = i;

                layout.Fields.Add(f);
            }

            xamTradeDataGrid.FieldLayouts.Add(layout);
        }
    }

    public class SampleDataItem : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Implementation
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        protected void SetProperty<T>(ref T field, T value, string propertyName)
        {
            field = value;
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

        #region properties

        private string property1;
        private string property2;
        private string property3;
        private string property4;
        private string property5;
        private string property6;
        private string property7;
        private string property8;
        private string property9;
        private string property10;
        private string property11;
        private string property12;
        private string property13;
        private string property14;
        private string property15;
        private string property16;
        private string property17;
        private string property18;
        private string property19;
        private string property20;
        private string property21;
        private string property22;
        private string property23;
        private string property24;
        private string property25;
        private string property26;
        private string property27;
        private string property28;
        private string property29;

        

        public string Property1
        {
            get { return property1; }
            set { SetProperty(ref property1, value, "Property1"); }
        }
        public string Property2
        {
            get { return property2; }
            set { SetProperty(ref property2, value, "Property2"); }
        }
        public string Property3
        {
            get { return property3; }
            set { SetProperty(ref property3, value, "Property3"); }
        }
        public string Property4
        {
            get { return property4; }
            set { SetProperty(ref property4, value, "Property4"); }
        }
        public string Property5
        {
            get { return property5; }
            set { SetProperty(ref property5, value, "Property5"); }
        }
        public string Property6
        {
            get { return property6; }
            set { SetProperty(ref property6, value, "Property6"); }
        }
        public string Property7
        {
            get { return property7; }
            set { SetProperty(ref property7, value, "Property7"); }
        }
        public string Property8
        {
            get { return property8; }
            set { SetProperty(ref property8, value, "Property8"); }
        }
        public string Property9
        {
            get { return property9; }
            set { SetProperty(ref property9, value, "Property9"); }
        }
        public string Property10
        {
            get { return property10; }
            set { SetProperty(ref property10, value, "Property10"); }
        }
        public string Property11
        {
            get { return property11; }
            set { SetProperty(ref property11, value, "Property11"); }
        }
        public string Property12
        {
            get { return property12; }
            set { SetProperty(ref property12, value, "Property12"); }
        }
        public string Property13
        {
            get { return property13; }
            set { SetProperty(ref property13, value, "Property13"); }
        }
        public string Property14
        {
            get { return property14; }
            set { SetProperty(ref property14, value, "Property14"); }
        }
        public string Property15
        {
            get { return property15; }
            set { SetProperty(ref property15, value, "Property15"); }
        }
        public string Property16
        {
            get { return property16; }
            set { SetProperty(ref property16, value, "Property16"); }
        }
        public string Property17
        {
            get { return property17; }
            set { SetProperty(ref property17, value, "Property17"); }
        }
        public string Property18
        {
            get { return property18; }
            set { SetProperty(ref property18, value, "Property18"); }
        }
        public string Property19
        {
            get { return property19; }
            set { SetProperty(ref property19, value, "Property19"); }
        }
        public string Property20
        {
            get { return property20; }
            set { SetProperty(ref property20, value, "Property20"); }
        }
        public string Property21
        {
            get { return property21; }
            set { SetProperty(ref property21, value, "Property21"); }
        }
        public string Property22
        {
            get { return property22; }
            set { SetProperty(ref property22, value, "Property22"); }
        }
        public string Property23
        {
            get { return property23; }
            set { SetProperty(ref property23, value, "Property23"); }
        }
        public string Property24
        {
            get { return property24; }
            set { SetProperty(ref property24, value, "Property24"); }
        }
        public string Property25
        {
            get { return property25; }
            set { SetProperty(ref property25, value, "Property25"); }
        }
        public string Property26
        {
            get { return property26; }
            set { SetProperty(ref property26, value, "Property26"); }
        }
        public string Property27
        {
            get { return property27; }
            set { SetProperty(ref property27, value, "Property27"); }
        }
        public string Property28
        {
            get { return property28; }
            set { SetProperty(ref property28, value, "Property28"); }
        }
        public string Property29
        {
            get { return property29; }
            set { SetProperty(ref property29, value, "Property29"); }
        }

        #endregion

        private Person person;
        public Person Person
        {
            get { return person; }
            set { SetProperty(ref person, value, "Person"); }
        }

        private string salesPersonName;
        public string SalesPersonName
        {
            get { return salesPersonName; }
            set { SetProperty(ref salesPersonName, value, "SalesPersonName"); }
        }

        private ObservableCollection<Person> people;
        public ObservableCollection<Person> People
        {
            get { return people; }
            set { SetProperty(ref people, value, "People"); }
        }
    }

    public class Person : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Implementation
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        protected void SetProperty<T>(ref T field, T value, string propertyName)
        {
            field = value;
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

        private string displayName;
        public string DisplayName
        {
            get { return displayName; }
            set { SetProperty(ref displayName, value, "DisplayName"); }
        }
    }

    public class SampleData : ObservableCollection<SampleDataItem>
    {
        public SampleData()
        {
            for (int row = 0; row < 100; row++)
            {
                SampleDataItem item = new SampleDataItem();

                for (int col = 1; col <= 29; col++)
                {
                    item.GetType().GetProperty("Property" + col).SetValue(item, "some value", null);
                }

                item.People = new ObservableCollection<Person>()
                {
                    new Person { DisplayName = "Joe" },
                    new Person { DisplayName = "Betty" },
                    new Person { DisplayName = "Margaret" },
                    new Person { DisplayName = "Mary" },
                    new Person { DisplayName = "Jim" },
                    new Person { DisplayName = "Gary" },
                    new Person { DisplayName = "Jerry" },
                };

                this.Add(item);
            }
        }
    }
}
